Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.clusterers
Class SimpleKMeans

    java.lang.Object
      weka.clusterers.Clusterer
          weka.clusterers.SimpleKMeans

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, NumberOfClustersRequestable, OptionHandler, WeightedInstancesHandler

    public class SimpleKMeans

extends Clusterer
implements NumberOfClustersRequestable, OptionHandler, WeightedInstancesHandler

Simple k means clustering class. Valid options are:

-N
Specify the number of clusters to generate.

-S
Specify random number seed.

Version:
  $Revision: 1.19.2.4 $
Author:
  Mark Hall (mhall@cs.waikato.ac.nz), Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  `Clusterer`, `OptionHandler`, Serialized Form

Constructor Summary
`SimpleKMeans()`

Method Summary
`void` | `buildClusterer(Instances data)` Generates a clusterer.
`int` | `clusterInstance(Instance instance)` Classifies a given instance.
`Instances` | `getClusterCentroids()`
`int[][][]` | `getClusterNominalCounts()`
`int[]` | `getClusterSizes()`
`Instances` | `getClusterStandardDevs()`
`int` | `getNumClusters()` gets the number of clusters to generate
`java.lang.String[]` | `getOptions()` Gets the current settings of SimpleKMeans
`int` | `getSeed()` Get the random number seed
`double` | `getSquaredError()`
`java.lang.String` | `globalInfo()` Returns a string describing this clusterer
`java.util.Enumeration` | `listOptions()` Returns an enumeration describing the available options..
`static void` | `main(java.lang.String[] argv)` Main method for testing this class.
`int` | `numberOfClusters()` Returns the number of clusters.
`java.lang.String` | `numClustersTipText()` Returns the tip text for this property
`java.lang.String` | `seedTipText()` Returns the tip text for this property
`void` | `setNumClusters(int n)` set the number of clusters to generate
`void` | `setOptions(java.lang.String[] options)` Parses a given list of options.
`void` | `setSeed(int s)` Set the random number seed
`java.lang.String` | `toString()` return a string describing this clusterer

Methods inherited from class weka.clusterers.Clusterer
`distributionForInstance, forName, makeCopies`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SimpleKMeans

    public SimpleKMeans()

Method Detail

### globalInfo

    public java.lang.String globalInfo()

  Returns a string describing this clusterer

  Returns:
    a description of the evaluator suitable for displaying in the explorer/experimenter gui

### buildClusterer

    public void buildClusterer(Instances data)
                        throws java.lang.Exception

  Generates a clusterer. Has to initialize all fields of the clusterer that are not being set via options.

  Specified by:
    `buildClusterer` in class `Clusterer`
  Parameters:
    `data` - set of instances serving as training data
  Throws:
    `java.lang.Exception` - if the clusterer has not been generated successfully

### clusterInstance

    public int clusterInstance(Instance instance)
                        throws java.lang.Exception

  Classifies a given instance.

  Overrides:
    `clusterInstance` in class `Clusterer`
  Parameters:
    `instance` - the instance to be assigned to a cluster
  Returns:
    the number of the assigned cluster as an interger if the class is enumerated, otherwise the predicted value
  Throws:
    `java.lang.Exception` - if instance could not be classified successfully

### numberOfClusters

    public int numberOfClusters()
                         throws java.lang.Exception

  Returns the number of clusters.

  Specified by:
    `numberOfClusters` in class `Clusterer`
  Returns:
    the number of clusters generated for a training dataset.
  Throws:
    `java.lang.Exception` - if number of clusters could not be returned successfully

### listOptions

    public java.util.Enumeration listOptions()

  Returns an enumeration describing the available options..

  Valid options are:

  -N
  Specify the number of clusters to generate. If omitted, EM will use cross validation to select the number of clusters automatically.

  -S
  Specify random number seed.

  Specified by:
    `listOptions` in interface `OptionHandler`
  Returns:
    an enumeration of all the available options.

### numClustersTipText

    public java.lang.String numClustersTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setNumClusters

    public void setNumClusters(int n)
                        throws java.lang.Exception

  set the number of clusters to generate

  Specified by:
    `setNumClusters` in interface `NumberOfClustersRequestable`
  Parameters:
    `n` - the number of clusters to generate
  Throws:
    `java.lang.Exception` - if the requested number of clusters in inapropriate

### getNumClusters

    public int getNumClusters()

  gets the number of clusters to generate

  Returns:
    the number of clusters to generate

### seedTipText

    public java.lang.String seedTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setSeed

    public void setSeed(int s)

  Set the random number seed

  Parameters:
    `s` - the seed

### getSeed

    public int getSeed()

  Get the random number seed

  Returns:
    the seed

### setOptions

    public void setOptions(java.lang.String[] options)
                    throws java.lang.Exception

  Parses a given list of options.

  Specified by:
    `setOptions` in interface `OptionHandler`
  Parameters:
    `options` - the list of options as an array of strings
  Throws:
    `java.lang.Exception` - if an option is not supported

### getOptions

    public java.lang.String[] getOptions()

  Gets the current settings of SimpleKMeans

  Specified by:
    `getOptions` in interface `OptionHandler`
  Returns:
    an array of strings suitable for passing to setOptions()

### toString

    public java.lang.String toString()

  return a string describing this clusterer

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    a description of the clusterer as a string

### getClusterCentroids

    public Instances getClusterCentroids()

### getClusterStandardDevs

    public Instances getClusterStandardDevs()

### getClusterNominalCounts

    public int[][][] getClusterNominalCounts()

### getSquaredError

    public double getSquaredError()

### getClusterSizes

    public int[] getClusterSizes()

### main

    public static void main(java.lang.String[] argv)

  Main method for testing this class.

  Parameters:
    `argv` - should contain the following arguments:

    -t training file [-N number of clusters]

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD